## maas 2.1.0~beta2+bzr5454

=== Makefile ===
python := python3.5

# pkg_resources makes some incredible noise about version numbers. They
# are not indications of bugs in MAAS so we silence them everywhere.
export PYTHONWARNINGS = \
  ignore:You have iterated over the result:RuntimeWarning:pkg_resources:

# Network activity can be suppressed by setting offline=true (or any
# non-empty string) at the command-line.
ifeq ($(offline),)
buildout := bin/buildout
else
buildout := bin/buildout buildout:offline=true
endif

# If offline has been selected, attempt to further block HTTP/HTTPS
# activity by setting bogus proxies in the environment.
ifneq ($(offline),)
export http_proxy := broken
export https_proxy := broken
endif

# Python enum modules.
py_enums := $(wildcard src/*/enum.py)
# JavaScript enum module (not modules).
js_enums := src/maasserver/static/js/enums.js
templates := $(shell find etc/maas/templates -type f)

# MAAS SASS stylesheets. The first input file (maas-styles.css) imports
# the others, so is treated specially in the target definitions.
scss_theme := include/nodejs/node_modules/cloud-vanilla-theme
scss_inputs := \
    src/maasserver/static/scss/build.scss \
    $(wildcard src/maasserver/static/scss/*/*.scss) \
    $(wildcard src/maasserver/static/scss/*/*/*.scss)
scss_output := src/maasserver/static/css/build.css

# Prefix commands with this when they need access to the database.
# Remember to add a dependency on bin/database from the targets in
# which those commands appear.
dbrun := bin/database --preserve run --

# Disable progress when running npm and warning log levels.
npm_install := NODE_ENV=production NPM_CONFIG_PROGRESS="false" npm install \
	--loglevel error --cache-min 600

# For things that care, postgresfixture for example, we always want to
# use the "maas" databases.
export PGDATABASE := maas

# For anything we start, we want to hint as to its root directory.
export MAAS_ROOT := $(CURDIR)/run

build: \
  bin/buildout \
  bin/database \
  bin/maas \
  bin/maas-rack \
  bin/maas-region \
  bin/twistd.rack \
  bin/twistd.region \
  bin/test.cli \
  bin/test.rack \
  bin/test.config \
  bin/test.region \
  bin/test.testing \
  bin/test.js \
  bin/test.e2e \
  bin/py bin/ipy \
  $(js_enums)

all: build doc

# Install all packages required for MAAS development & operation on
# the system. This may prompt for a password.
install-dependencies: release := $(shell lsb_release -c -s)
install-dependencies:
	sudo DEBIAN_FRONTEND=noninteractive apt-get -y \
	    --no-install-recommends install $(shell sort -u \
	        $(addprefix required-packages/,base build dev doc $(release)) | sed '/^\#/d')
	sudo DEBIAN_FRONTEND=noninteractive apt-get -y \
	    purge $(shell sort -u required-packages/forbidden | sed '/^\#/d')

.bzrignore: FORCE
	LC_ALL=C.UTF-8 sort -f $@ --output $@

.gitignore: .bzrignore
	sed 's:^[.]/:/:' $^ > $@
	echo '/src/**/*.pyc' >> $@
	echo '/etc/**/*.pyc' >> $@

run/etc/ntp.conf: templates/ntp.conf
	@mkdir -p $(@D)
	@cp templates/ntp.conf $@

configure-buildout:
	utilities/configure-buildout

sudoers:
	utilities/grant-nmap-permissions
	utilities/install-arp-observer
	utilities/install-dhcp-observer

bin/buildout: bootstrap-buildout.py
	@utilities/configure-buildout --quiet
	$(python) bootstrap-buildout.py --allow-site-packages
	@touch --no-create $@  # Ensure it's newer than its dependencies.

bin/database: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install database
	@touch --no-create $@

bin/maas-region bin/twistd.region: \
    bin/buildout buildout.cfg versions.cfg setup.py \
    $(js_enums) $(scss_output)
	$(buildout) install region
	@touch --no-create $@

bin/test.region: \
  bin/buildout buildout.cfg versions.cfg setup.py $(js_enums) \
  bin/maas-region bin/maas-rack
	$(buildout) install region-test
	@touch --no-create $@

bin/maas: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install cli
	@touch --no-create $@

bin/test.cli: bin/buildout buildout.cfg versions.cfg setup.py bin/maas
	$(buildout) install cli-test
	@touch --no-create $@

bin/test.js: bin/karma bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install js-test
	@touch --no-create $@

bin/test.e2e: bin/protractor bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install e2e-test
	@touch --no-create $@

# bin/maas-region is needed for South migration tests. bin/flake8 is
# needed for checking lint and bin/sass is needed for checking css.
bin/test.testing: \
  bin/maas-region bin/flake8 bin/sass bin/buildout \
  buildout.cfg versions.cfg setup.py
	$(buildout) install testing-test
	@touch --no-create $@

bin/maas-rack bin/twistd.rack: \
  bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install rack
	@touch --no-create $@

bin/test.rack: \
  bin/buildout buildout.cfg versions.cfg setup.py bin/maas-rack \
  run/etc/ntp.conf
	$(buildout) install rack-test
	@touch --no-create $@

bin/test.config: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install config-test
	@touch --no-create $@

bin/flake8: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install flake8
	@touch --no-create $@

bin/sphinx bin/sphinx-build: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install sphinx
	@touch --no-create $@

bin/py bin/ipy: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install repl
	@touch --no-create bin/py bin/ipy

bin/coverage: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install coverage
	@touch --no-create bin/coverage

define karma-deps
  jasmine-core@2.4.1
  karma@0.13.19
  karma-chrome-launcher@0.2.2
  karma-firefox-launcher@0.1.7
  karma-jasmine@0.3.6
  karma-opera-launcher@0.3.0
  karma-phantomjs-launcher@0.2.3
  karma-failed-reporter@0.0.3
  phantomjs@2.1.7
endef

bin/karma: deps = $(strip $(karma-deps))
bin/karma: prefix = include/nodejs
bin/karma:
	@mkdir -p $(@D) $(prefix)
	$(npm_install) --prefix $(prefix) $(deps)
	@ln -srf $(prefix)/node_modules/karma/bin/karma $@

bin/protractor: prefix = include/nodejs
bin/protractor:
	@mkdir -p $(@D) $(prefix)
	$(npm_install) --prefix $(prefix) protractor@3.0.0
	@ln -srf $(prefix)/node_modules/protractor/bin/protractor $@

bin/sass: prefix = include/nodejs
bin/sass:
	@mkdir -p $(@D) $(prefix)
	$(npm_install) --prefix $(prefix) node-sass@3.4.2
	@ln -srf $(prefix)/node_modules/node-sass/bin/node-sass $@

define test-scripts
  bin/test.cli
  bin/test.rack
  bin/test.config
  bin/test.region
  bin/test.testing
  bin/test.js
endef

lxd:
	utilities/configure-lxd-profile
	utilities/create-lxd-xenial-image

test+lxd: lxd $(strip $(test-scripts))
	utilities/isolated-make-test

test: $(strip $(test-scripts))
	@bin/maas-region makemigrations --dry-run --exit && exit 1 ||:
	@$(RM) coverage.data .failed
	$(foreach test,$^,$(test-template);)
	@test ! -f .failed

test-failed: $(strip $(test-scripts))
	@bin/maas-region makemigrations --dry-run --exit && exit 1 ||:
	@$(RM) coverage.data .failed
	$(foreach test,$^,$(test-template-failed);)
	@test ! -f .failed

clean-failed:
	$(RM) .noseids

define test-template
$(test) --with-xunit --xunit-file=xunit.$(notdir $(test)).xml || touch .failed
endef

define test-template-failed
  $(test) --with-xunit --xunit-file=xunit.$(notdir $(test)).xml --failed || \
  $(test) --with-xunit --xunit-file=xunit.$(notdir $(test)).xml --failed || \
  touch .failed
endef

smoke: lint bin/maas-region bin/test.rack
	@bin/maas-region makemigrations --dry-run --exit && exit 1 ||:
	@bin/test.rack --stop

test+coverage: export NOSE_WITH_COVERAGE = 1
test+coverage: test

coverage-report: coverage/index.html
	sensible-browser $< > /dev/null 2>&1 &

coverage.xml: bin/coverage coverage.data
	bin/coverage xml --include 'src/*' -o $@

coverage/index.html: revno = $(or $(shell bzr revno 2>/dev/null),???)
coverage/index.html: bin/coverage coverage.data
	@$(RM) -r $(@D)
	bin/coverage html --include 'src/*' \
	    --omit 'src/*/tests/*,src/*/testing/*' \
	    --title "MAAS r$(revno)" --directory $(@D)

coverage.data:
	@$(error Use `$(MAKE) test+coverage` to generate coverage data, \
	    or invoke a test script using the `--with-coverage` flag)

lint: lint-py lint-py-imports lint-js lint-doc lint-rst

pocketlint = $(call available,pocketlint,python-pocket-lint)

# XXX jtv 2014-02-25: Clean up this lint, then make it part of "make lint".
lint-css: sources = src/maasserver/static/css
lint-css:
	@find $(sources) -type f \
	    -print0 | xargs -r0 $(pocketlint) --max-length=120

# Python lint checks are time-intensive, so we run them in parallel.  It may
# make things matters worse if the files need to be read from disk, though, so
# this may need more tuning.
# The -n50 -P4 setting roughly doubled speed on a high-end system with SSD and
# all the files in cache.
lint-py: sources = $(wildcard *.py contrib/*.py) src templates twisted utilities etc
lint-py: bin/flake8
	@find $(sources) -name '*.py' \
	  ! -path '*/migrations/*' ! -path '*/south_migrations/*' \
	  ! -path 'src/provisioningserver/twisted/*' ! -path 'ez_setup.py' \
	  ! -path 'src/maasserver/data/*' -print0 \
	    | xargs -r0 -n50 -P4 bin/flake8 --ignore=E123,E402,E731 \
	    --config=/dev/null

# Statically check imports against policy.
lint-py-imports:
	@utilities/check-imports

lint-doc:
	@utilities/doc-lint

# JavaScript lint is checked in parallel for speed.  The -n20 -P4 setting
# worked well on a multicore SSD machine with the files cached, roughly
# doubling the speed, but it may need tuning for slower systems or cold caches.
lint-js: sources = src/maasserver/static/js
lint-js:
	@find $(sources) -type f ! -path '*/angular/3rdparty/*' \
	    '(' -name '*.html' -o -name '*.js' ')' -print0 \
		| xargs -r0 -n20 -P4 $(pocketlint)

# Apply automated formatting to all Python files.
format: sources = $(wildcard *.py contrib/*.py) src templates twisted utilities etc
format:
	@find $(sources) -name '*.py' -print0 | xargs -r0 utilities/format-imports

# Update copyright dates from version history. Try to avoid updating
# 3rd-party code by checking for "Canonical" or "MAAS" on the same line
# as the copyright header.
copyright:
	@bzr ls --versioned --recursive --kind=file --null | \
	    xargs -r0 egrep -iI 'copyright.*(canonical|maas)' -lZ | \
	    xargs -r0 bzr update-copyright --quiet --force-range

check: clean test

docs/api.rst: bin/maas-region src/maasserver/api/doc_handler.py syncdb
	bin/maas-region generate_api_doc > $@

sampledata: bin/maas-region bin/database syncdb
	$(dbrun) bin/maas-region generate_sample_data

doc: bin/sphinx docs/api.rst
	bin/sphinx

docs/_build/html/index.html: doc

doc-browse: docs/_build/html/index.html
	sensible-browser $< > /dev/null 2>&1 &

doc-with-versions: bin/sphinx docs/api.rst
	$(MAKE) -C docs/_build SPHINXOPTS="-A add_version_switcher=true" html

man: $(patsubst docs/man/%.rst,man/%,$(wildcard docs/man/*.rst))

man/%: docs/man/%.rst | bin/sphinx-build
	bin/sphinx-build -b man docs man $^

enums: $(js_enums)

$(js_enums): bin/py src/maasserver/utils/jsenums.py $(py_enums)
	bin/py -m maasserver.utils.jsenums $(py_enums) > $@

styles: clean-styles $(scss_output)

$(scss_output): bin/sass $(scss_theme) $(scss_inputs)
	bin/sass --include-path=src/maasserver/static/scss \
	    --output-style compressed $(scss_inputs) -o $(dir $@)

$(scss_theme): prefix = include/nodejs
$(scss_theme):
	$(npm_install) --prefix $(prefix) cloud-vanilla-theme@0.0.22

clean-styles:
	$(RM) $(scss_output)

clean: stop clean-run clean-failed
	find . -type f -name '*.py[co]' -print0 | xargs -r0 $(RM)
	find . -type d -name '__pycache__' -print0 | xargs -r0 $(RM) -r
	find . -type f -name '*~' -print0 | xargs -r0 $(RM)
	find . -type f -name dropin.cache -print0 | xargs -r0 $(RM)
	$(RM) -r media/demo/* media/development
	$(RM) $(js_enums) $(js_enums).tmp
	$(RM) src/maasserver/data/templates.py
	$(RM) *.log
	$(RM) docs/api.rst
	$(RM) -r docs/_autosummary docs/_build
	$(RM) -r man/.doctrees
	$(RM) coverage.data coverage.xml
	$(RM) -r coverage
	$(RM) -r .hypothesis

=== debian/changelog ===
maas (2.1.0~beta2+bzr5454-0ubuntu1) yakkety; urgency=medium

  * MAAS new upstream bugfix release. MAAS 2.1.0b2-bzr5454 (FFe LP: #1629909):
    - [2.1] Bootloaders not downloaded on initial import (LP: #1630394)
    - Cryptic error when PXE-boot requires an image not yet imported (LP: #1611949)
    - [2.0, 2.1, UI] MAAS webui allows boot disk to be changed on an
      already deployed node (LP: #1625676)
    - [2.1] Rename "Networks" tab to "Subnets" (LP: #1630591)
    - [2.1] netaddr assumes MAC OUI is ascii (LP: #1628761)
    - [2.1, 2.0] Can't input dynamic range on "Enable DHCP" after I deleted
      the dynamic range (LP: #1619262)
    - Machine unable to pxe with no-such-image while non-related images are
      being imported (LP: #1612203)
    - External DHCP detection is broken for a variety of reasons (LP: #1628645)
    - [2.1] expected string or bytes-like object (LP: #1627362)
    - [2.1] When trying to release a node, it gets stuck in releasing if
      there is no rack controller to power control (LP: #1614659)
    - WebUI needs a filter for deployed OS (LP: #1445941)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 05 Oct 2016 10:59:45 -0400

maas (2.1.0~beta1+bzr5433-0ubuntu1) yakkety; urgency=medium

  * MAAS new upstream release. MAAS 2.1.0b1-bzr5433 (FFe LP: #1629909):
    - Support for new version of streams.
    - Bootloaders are now downloaded from the streams.
    - Support for Low Latency kernels.
    - Support for new hardware enablement kernels.
    - Device discovery
      - UI ability to Map a network as an action.
      - Ability to select interval of active discovery.
      - Ability to enable active discovery per subnet.
  * Remove old template files on package removal.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Tue, 27 Sep 2016 14:44:26 -0400

maas (2.0.0+bzr5189-0ubuntu1) yakkety; urgency=medium

  * New upstream release, 2.0.0 bzr5189:
    - Cluster Controllers now deprecated. Introducing Rack Controllers.
      + Machine no longer belong to Rack Controllers.
      + High availability it is now supported.
      + Rack Controllers manage DHCP on the Fabric Level.
    - Region Controller high availability and scalability.
      + Ability to configure multiple Region Controller API endpoints.
    - API 1.0 has been deprecated. Introducing new API 2.0.
    - MAAS is introducing IP Ranges and deprecated the Static Range.
      + MAAS now controls the whole subnet.
      + The static Range has now been deprecated.
      + Users can now only create a dynamic or reserved range.
    - MAAS Static Range has been deprecated. MAAS Controls the whole Subnet.
    - New networks GUI.
    - MAAS now fully manages DNS.
    - Extended Storage Support. Includes:
      + XFS, Mount Options, Swap Partitions, tmpfs/ramfs.
    - Adding support for DHCP Snippets.
      + Creates extra custom DHCP config at the Node, Subnet and Global level.
    - MAAS Proxy is now managed by MAAS.
    - Service Tracking. MAAS now tracks status of the several services it runs.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 17 Aug 2016 09:24:17 +0100

maas (2.0.0~rc4+bzr5187-0ubuntu1) yakkety; urgency=medium

  * New upstream release, 2.0.0 RC4 bzr5187:
    - Mirror URL contains double slash (/) after hostname, impacting
      proxy cachaility. (LP: #1592666)
    - [2.0rc2] Static IP address are allowed to be created in a dynamic
      range. (LP: #1604461)
    - When juju adds containers to MAAS, ensure they inherit the parent
      machine domain name, if none is passed by Juju. (LP: #1604461)
    - UI error while generating a MAAS key (token). (LP: #1611342)
    - apiclient.maas_client.MAASClient.post() always sets an op in
      the query string (LP: #1610414)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 27 Jul 2016 22:26:55 -0400

maas (2.0.0~rc3+bzr5180-0ubuntu2) yakkety; urgency=medium

  * Really fix by the determination of the default gateway, otherwise
    automatically chose localhost. (LP: #1607112)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 27 Jul 2016 22:20:09 -0400

maas (2.0.0~rc3+bzr5180-0ubuntu1) yakkety; urgency=medium

  * New upstream release, 2.0.0 RC3 bzr5180:
    - CLI version command doesn't work (2.0) (LP: #1557434)
    - [2.0rc1] MAAS does not respect default subnet's DNS server when
      choosing default DNS (LP: #1576116)
    - [2.0RC1] MAAS displays every power query on the summarized view of
      node event log (LP: #1594991)
    - [2.0] Loading latest machine events can make web browser
      unresponsive (LP: #1598028)
    - [2.0rc1] MAAS doesn't honor DNS settings for a subnet for
      DHCP (LP: #1600720)
    - [2.0rc1] drop arm64/efi grub module workaround (LP: #1600285)
    - maas login yields "ImportError: No module named
      'maasserver'" (LP: #1604169)
    - [doc] events API limit,before, after options not
      documented (LP: #1604901)
    - RackController.get_image_sync_status causes huge load
      on regiond process (LP: #1604465)
    - [2.0b8] MAAS is automatically monitoring timeouts. (LP: #1598149)
    - [2.0] Error messaging about monitor expiry has been
      dropped (LP: #1605252)
    - [2.0rc2] Can't get node-results via cli/api (LP: #1602721)
    - node set to "failed deployment" for no visible reason (LP: #1604962)
    - Event log should always include a reason why a node was
      marked Failed Deployment (LP: #1604987)
  * If no default route is present in the system, configure maas_url on
    regiond.conf to localhost to allow the user to tell MAAS what IP to use.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Fri, 22 Jul 2016 18:05:45 -0400

maas (2.0.0~rc2+bzr5156-0ubuntu1) yakkety; urgency=medium

  * New upstream release, 2.0.0 RC2 bzr5156:
    - Pick up wrong grub.cfg if another filesystem exists (LP: #1582070)
    - [2.0] confusing reverse DNS lookups because MAAS creates multiple
      PTR records (LP: #1599223)
    - [2.0] reverse DNS sometimes assigns FQDN where it should assign


=== debian/control ===
Source: maas
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper (>= 8.1.0~),
               dh-apport,
               dh-python,
               dh-systemd,
               po-debconf,
               python3-all,
               python3-django,
               python3-setuptools,
               python3-twisted
Standards-Version: 3.9.7
X-Python3-Version: >= 3.5
Homepage: http://maas.io/

Package: maas
Architecture: all
Depends: maas-rack-controller (= ${binary:Version}),
         maas-region-controller (= ${binary:Version}),
         python3-django-maas (= ${binary:Version}),
         ${misc:Depends}
Description: "Metal as a Service" is a physical cloud and IPAM
 MAAS runs a software-defined data centre - it turns a collection of physical
 servers and switches into a bare metal cloud with full open source IP address
 management (IPAM) and instant provisioning on demand.
 .
 MAAS controls the servers through IPMI or another BMC or  converged chassis
 controller such as Cisco UCS. It provides a full inventory  of components,
 and can install Ubuntu, CentOS or Windows very fast on any  server under
 its control. It can also track and provide DHCP and DNS for other devices
 on the network.
 .
 MAAS handles VLANs and fabrics that span many trunked switches, as well as
 the routing-centric infrastructure typically used for large-scale OpenStack
 or other scale-out deployments. MAAS manages IP addresses and provides APIs
 for address assignment and release. MAAS can also allocate IP addresses for
 containers on machines, and release them when the machine is repurposed. MAAS
 provides PXE, DHCP, DNS and other low-level  services to ensure the cluster
 works smoothly.
 .
 MAAS works with any configuration system, and is recommended by the teams
 behind both Chef and Juju as a physical provisioning system.
 .
 MAAS provides:
 .
  * Hardware inventory of servers
  * Dynamic provisioning based on name or attributes such as disk, RAM, cores,
    nics, networking, gpu’s or architecture
  * DNS and DHCP as needed
  * PXE boot services
 .
 This package is a metapackage which installs all of the separate components
 of MAAS on a single machine.

Package: maas-common
Architecture: all
Depends: rsyslog,
         ${misc:Depends}
Breaks: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 )
Replaces: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 )
Description: MAAS server common files
 This package contains the common files for any MAAS installation.

Package: maas-region-api
Architecture: all
Depends: apache2,
         bind9utils,
         iproute2,
         libjs-angularjs,
         libjs-yui3-full,
         libjs-yui3-min,
         maas-cli (=${binary:Version}),
         maas-common (= ${binary:Version}),
         maas-proxy (= ${binary:Version}),
         ntp,
         python3-bson,
         python3-django,
         python3-django-maas (= ${binary:Version}),
         python3-django-piston3,
         python3-djorm-ext-pgarray,
         python3-maas-provisioningserver (= ${binary:Version}),
         python3-petname,
         python3-requests,
         ubuntu-cloudimage-keyring,
         ${misc:Depends},
         ${python3:Depends}
Conflicts: maas-region-controller-min
Replaces: maas-region-controller-min
Provides: maas-region-controller-min
Description: Region controller API service for MAAS
 The MAAS region controller consists of REST API services and a postgres
 database. This package installs only the API services (maas-regiond).
 Use it to scale out the API front-end of your MAAS region controller.

Package: maas-region-controller
Architecture: all
Depends: avahi-utils,
         dbconfig-pgsql,
         iputils-ping,
         maas-dns (= ${binary:Version}),
         maas-region-api (= ${binary:Version}),
         postgresql (>= 9.1),
         tcpdump,
         ${misc:Depends},
Recommends: openssh-server
Suggests: nmap
Description: Region Controller for MAAS
 The MAAS region controller (maas-regiond) is the REST API server for
 all MAAS clients, and the postgres database that maintains machine
 state for the entire data centre (or “region”). The region controller 
 an be scaled-out and highly available given the appropriate postgres
 setup and additional API servers.
 .
 This package installs the postgres database and the API server, so it
 is appropriate for the initial installation of a new MAAS region. To
 scale out the controller or make it highly available, install
 maas-region-controller-api on additional servers and ensure the
 postgres database is HA too.

Package: python3-maas-provisioningserver
Section: python
Architecture: all
Depends: archdetect-deb,
         lshw,
         openssh-client,
         python3-attr,
         python3-bson,
         python3-crochet,
         python3-curtin (>> 0.1.0~bzr351),
         python3-distro-info,
         python3-formencode,
         python3-jsonschema,
         python3-lxml,
         python3-maas-client (= ${binary:Version}),
         python3-netifaces,
         python3-oauth,
         python3-oauthlib,
         python3-paramiko,
         python3-pexpect,
         python3-pyparsing,
         python3-pyvmomi,
         python3-seamicroclient,
         python3-simplejson,
         python3-simplestreams,
         python3-tempita,
         python3-twisted,
         python3-txtftp,
         python3-yaml,
         python3-zope.interface,
         isc-dhcp-client,
         iproute2,
         ${misc:Depends},
         ${python3:Depends}
Description: MAAS server provisioning libraries (Python 3)
 This package provides the MAAS provisioning server python libraries.
 .
 This package contains Python 3 libraries.

Package: maas-cli
Architecture: all
Depends: python3-maas-client (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends}
Conflicts: maas-region-controller-min (<= 1.5+bzr1909-0ubuntu1)
Replaces: maas-region-controller-min (<= 1.5+bzr1909-0ubuntu1)
Description: MAAS client and command-line interface
 This package contains the 'maas' command-line interface, which
 talks to the MAAS region controller REST API. Use the maas command
 to login to MAAS and drive the data centre entirely from the
 command-line.

Package: python3-maas-client
Section: python
Architecture: all
Depends: python3-httplib2,
         python3-oauth,
         ${misc:Depends},
         ${python3:Depends}
Breaks: python-maas-client, maas-cli ( <= 2.0.0~alpha4+bzr4843-0ubuntu1 )
Replaces: python-maas-client, maas-cli ( <= 2.0.0~alpha4+bzr4843-0ubuntu1 )
Description: MAAS python API client (Python 3)
 This package contains the MAAS client API Python modules.
 .
 This package contains Python 3 modules.

Package: maas-rack-controller
Architecture: all
Depends: authbind,
         avahi-utils,
         bind9utils,
         distro-info,
         freeipmi-tools,
         grub-common,
         iputils-ping,
         maas-cli (=${binary:Version}),
         maas-common (=${binary:Version}),
         maas-dhcp (=${binary:Version}),
         ntp,
         pxelinux | syslinux-common (<< 3:6.00~pre4+dfsg-5),
         python3-httplib2,
         python3-maas-provisioningserver (=${binary:Version}),
         python3-netaddr,
         python3-tempita,
         python3-twisted,
         python3-zope.interface,
         syslinux-common,
         tcpdump,
         tgt,
         uuid-runtime,
         wget,
         ${misc:Depends},
         ${python3:Depends}
Suggests: amtterm, ipmitool, libvirt-bin, nmap, wsmancli
Conflicts: tftpd-hpa
Breaks: python-maas-provisioningserver,
        maas-cluster-controller
Replaces: python-maas-provisioningserver,
          maas-cluster-controller
Description: Rack Controller for MAAS
 The MAAS rack controller (maas-rackd) provides highly available, fast
 and local broadcast services to the machines provisioned by MAAS. You
 need a MAAS rack controller attached to each fabric (which is a set of
 trunked switches). You can attach multiple rack controllers to these
 physical networks for high availability, with secondary rack controllers
 automatically stepping to provide these services if the primary rack
 controller fails.
 .
 A common configuration is to have a rack controller in each rack, with
 a fast primary network interface to the rack switch and secondary
 network interfaces on one or two other nearby racks for high
 availability redundancy.
 .
 This package depends on the necessary components to provide iSCSI,
 DHCP, TFTP and power management.

Package: python3-django-maas
Section: python
Architecture: all
Depends: python3-apt,
         python3-attr,
         python3-convoy,
         python3-crochet,
         python3-curtin (>> 0.1.0~bzr275),
         python3-lxml,
         python3-maas-client (= ${binary:Version}),
         python3-netaddr,
         python3-psycopg2,
         python3-sphinx,
         python3-tempita,
         python3-twisted,
         python3-zope.interface,
         ${misc:Depends},
         ${python3:Depends}
Breaks: python-django-maas
Replaces: python-django-maas
Description: MAAS server Django web framework (Python 3)
 This package provides the Django web framework for MAAS.
 .
 This package contains Python 3 modules.

Package: maas-dhcp
Architecture: all
Depends: isc-dhcp-server (>= 4.3.3-5ubuntu10~), ${misc:Depends}
Description: MAAS DHCP server
 This package installs and configures a DHCP server that can be used by
 MAAS, and enhances the overall MAAS user experience.

Package: maas-dns
Architecture: all
Depends: bind9 (>= 1:9.10.3.dfsg.P2-5~),
         maas-region-api (= ${binary:Version}),
         ${misc:Depends}
Conflicts: dnsmasq
Description: MAAS DNS server
 This package installs and configures a DNS server that can be used by
 MAAS, and enhances the overall MAAS user experience.

Package: maas-proxy
Architecture: all
Depends: squid (>> 3.5), ${misc:Depends}
Conflicts: squid-deb-proxy
Description: MAAS Caching Proxy
 This package installs and configures a Caching Proxy server that can be
 used by MAAS. It enhances the overall MAAS user experience.

Package: maas-region-udeb
Package-Type: udeb
Section: debian-installer
Architecture: all
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
XB-Installer-Menu-Item: 2350
Description: Install a MAAS server (installer integration)

Package: maas-rack-udeb
Package-Type: udeb
Section: debian-installer
Architecture: all
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
XB-Installer-Menu-Item: 2350
Description: Install a MAAS Rack controller (installer integration)

## maas 2.1.4%2bbzr5591

=== Makefile ===
--- 
+++ 
@@ -273,7 +273,7 @@
 	@$(error Use `$(MAKE) test+coverage` to generate coverage data, \
 	    or invoke a test script using the `--with-coverage` flag)
 
-lint: lint-py lint-py-imports lint-js lint-doc lint-rst
+lint: lint-py lint-py-complexity lint-py-imports lint-js lint-doc lint-rst
 
 pocketlint = $(call available,pocketlint,python-pocket-lint)
 
@@ -283,23 +283,33 @@
 	@find $(sources) -type f \
 	    -print0 | xargs -r0 $(pocketlint) --max-length=120
 
-# Python lint checks are time-intensive, so we run them in parallel.  It may
-# make things matters worse if the files need to be read from disk, though, so
-# this may need more tuning.
-# The -n50 -P4 setting roughly doubled speed on a high-end system with SSD and
-# all the files in cache.
-lint-py: sources = $(wildcard *.py contrib/*.py) src templates twisted utilities etc
+# Python lint checks are time-intensive, but flake8 now knows how to run
+# parallel jobs, and does so by default.
+lint-py: sources = setup.py src templates twisted
 lint-py: bin/flake8
 	@find $(sources) -name '*.py' \
+	  ! -path '*/migrations/*' ! -path '*/south_migrations/*' -print0 \
+	    | xargs -r0 bin/flake8 --ignore=E123,E402,E731 --isolated
+
+# Ignore tests when checking complexity. The maximum complexity ought to
+# be close to 10 but MAAS has many functions that are over that so we
+# start with a much higher number. Over time we can ratchet it down.
+lint-py-complexity: maximum=26
+lint-py-complexity: sources = setup.py src templates twisted
+lint-py-complexity: bin/flake8
+	@find $(sources) -name '*.py' \
 	  ! -path '*/migrations/*' ! -path '*/south_migrations/*' \
-	  ! -path 'src/provisioningserver/twisted/*' ! -path 'ez_setup.py' \
-	  ! -path 'src/maasserver/data/*' -print0 \
-	    | xargs -r0 -n50 -P4 bin/flake8 --ignore=E123,E402,E731 \
-	    --config=/dev/null
+	  ! -path '*/tests/*' ! -path '*/testing/*' ! -name 'testing.py' \
+	  -print0 | xargs -r0 bin/flake8 --ignore=E123,E402,E731 \
+	              --isolated --max-complexity=$(maximum)
 
 # Statically check imports against policy.
+lint-py-imports: sources = setup.py src templates twisted
 lint-py-imports:
 	@utilities/check-imports
+	@find $(sources) -name '*.py' \
+	  ! -path '*/migrations/*' ! -path '*/south_migrations/*' \
+	  -print0 | xargs -r0 utilities/find-early-imports
 
 lint-doc:
 	@utilities/doc-lint
@@ -370,16 +380,3 @@
 
 clean: stop clean-run clean-failed
 	find . -type f -name '*.py[co]' -print0 | xargs -r0 $(RM)
-	find . -type d -name '__pycache__' -print0 | xargs -r0 $(RM) -r
-	find . -type f -name '*~' -print0 | xargs -r0 $(RM)
-	find . -type f -name dropin.cache -print0 | xargs -r0 $(RM)
-	$(RM) -r media/demo/* media/development
-	$(RM) $(js_enums) $(js_enums).tmp
-	$(RM) src/maasserver/data/templates.py
-	$(RM) *.log
-	$(RM) docs/api.rst
-	$(RM) -r docs/_autosummary docs/_build
-	$(RM) -r man/.doctrees
-	$(RM) coverage.data coverage.xml
-	$(RM) -r coverage
-	$(RM) -r .hypothesis

## maas 2.2.0~rc1+bzr5922

=== Makefile ===
--- 
+++ 
@@ -28,11 +28,9 @@
 
 # MAAS SASS stylesheets. The first input file (maas-styles.css) imports
 # the others, so is treated specially in the target definitions.
-scss_theme := include/nodejs/node_modules/cloud-vanilla-theme
-scss_inputs := \
-    src/maasserver/static/scss/build.scss \
-    $(wildcard src/maasserver/static/scss/*/*.scss) \
-    $(wildcard src/maasserver/static/scss/*/*/*.scss)
+scss_theme := include/nodejs/node_modules/maas-gui-vanilla-theme
+scss_input := src/maasserver/static/scss/build.scss
+scss_deps := $(wildcard src/maasserver/static/scss/_*.scss)
 scss_output := src/maasserver/static/css/build.css
 
 # Prefix commands with this when they need access to the database.
@@ -49,7 +47,7 @@
 export PGDATABASE := maas
 
 # For anything we start, we want to hint as to its root directory.
-export MAAS_ROOT := $(CURDIR)/run
+export MAAS_ROOT := $(CURDIR)/.run
 
 build: \
   bin/buildout \
@@ -61,11 +59,12 @@
   bin/twistd.region \
   bin/test.cli \
   bin/test.rack \
-  bin/test.config \
   bin/test.region \
+  bin/test.region.legacy \
   bin/test.testing \
   bin/test.js \
   bin/test.e2e \
+  bin/test.parallel \
   bin/py bin/ipy \
   $(js_enums)
 
@@ -86,12 +85,6 @@
 
 .gitignore: .bzrignore
 	sed 's:^[.]/:/:' $^ > $@
-	echo '/src/**/*.pyc' >> $@
-	echo '/etc/**/*.pyc' >> $@
-
-run/etc/ntp.conf: templates/ntp.conf
-	@mkdir -p $(@D)
-	@cp templates/ntp.conf $@
 
 configure-buildout:
 	utilities/configure-buildout
@@ -106,8 +99,16 @@
 	$(python) bootstrap-buildout.py --allow-site-packages
 	@touch --no-create $@  # Ensure it's newer than its dependencies.
 
+# buildout.cfg refers to .run and .run-e2e.
+buildout.cfg: .run .run-e2e
+
 bin/database: bin/buildout buildout.cfg versions.cfg setup.py
 	$(buildout) install database
+	@touch --no-create $@
+
+bin/test.parallel: \
+  bin/buildout buildout.cfg versions.cfg setup.py
+	$(buildout) install parallel-test
 	@touch --no-create $@
 
 bin/maas-region bin/twistd.region: \
@@ -122,6 +123,11 @@
 	$(buildout) install region-test
 	@touch --no-create $@
 
+bin/test.region.legacy: \
+    bin/buildout buildout.cfg versions.cfg setup.py $(js_enums)
+	$(buildout) install region-test-legacy
+	@touch --no-create $@
+
 bin/maas: bin/buildout buildout.cfg versions.cfg setup.py
 	$(buildout) install cli
 	@touch --no-create $@
@@ -134,14 +140,15 @@
 	$(buildout) install js-test
 	@touch --no-create $@
 
-bin/test.e2e: bin/protractor bin/buildout buildout.cfg versions.cfg setup.py
+bin/test.e2e: \
+    bin/protractor bin/buildout buildout.cfg versions.cfg setup.py
 	$(buildout) install e2e-test
 	@touch --no-create $@
 
 # bin/maas-region is needed for South migration tests. bin/flake8 is
 # needed for checking lint and bin/sass is needed for checking css.
 bin/test.testing: \
-  bin/maas-region bin/flake8 bin/sass bin/buildout \
+  bin/maas-region bin/flake8 bin/sass $(scss_theme) bin/buildout \
   buildout.cfg versions.cfg setup.py
 	$(buildout) install testing-test
 	@touch --no-create $@
@@ -152,13 +159,8 @@
 	@touch --no-create $@
 
 bin/test.rack: \
-  bin/buildout buildout.cfg versions.cfg setup.py bin/maas-rack \
-  run/etc/ntp.conf
+  bin/buildout buildout.cfg versions.cfg setup.py bin/maas-rack bin/py
 	$(buildout) install rack-test
-	@touch --no-create $@
-
-bin/test.config: bin/buildout buildout.cfg versions.cfg setup.py
-	$(buildout) install config-test
 	@touch --no-create $@
 
 bin/flake8: bin/buildout buildout.cfg versions.cfg setup.py
@@ -211,8 +213,8 @@
 define test-scripts
   bin/test.cli
   bin/test.rack
-  bin/test.config
   bin/test.region
+  bin/test.region.legacy
   bin/test.testing
   bin/test.js
 endef
@@ -224,20 +226,32 @@
 test+lxd: lxd $(strip $(test-scripts))
 	utilities/isolated-make-test
 
-test: $(strip $(test-scripts))
+test: bin/test.parallel bin/coverage
+	@$(RM) .coverage .coverage.*
+	@bin/test.parallel --subprocess-per-core
+	@bin/coverage combine
+
+test-serial: $(strip $(test-scripts))
 	@bin/maas-region makemigrations --dry-run --exit && exit 1 ||:
-	@$(RM) coverage.data .failed
+	@$(RM) .coverage .coverage.* .failed
 	$(foreach test,$^,$(test-template);)
 	@test ! -f .failed
 
 test-failed: $(strip $(test-scripts))
 	@bin/maas-region makemigrations --dry-run --exit && exit 1 ||:
-	@$(RM) coverage.data .failed
+	@$(RM) .coverage .coverage.* .failed
 	$(foreach test,$^,$(test-template-failed);)
 	@test ! -f .failed
 
 clean-failed:
 	$(RM) .noseids
+
+src/maasserver/testing/initial.maas_test.sql: bin/database syncdb
+	bin/database --preserve run -- \
+	    pg_dump maas --no-owner --no-privileges \
+	        --format=plain > $@
+
+test-initial-data: src/maasserver/testing/initial.maas_test.sql
 
 define test-template
 $(test) --with-xunit --xunit-file=xunit.$(notdir $(test)).xml || touch .failed
@@ -253,27 +267,28 @@
 	@bin/maas-region makemigrations --dry-run --exit && exit 1 ||:
 	@bin/test.rack --stop
 
-test+coverage: export NOSE_WITH_COVERAGE = 1
-test+coverage: test
+test-serial+coverage: export NOSE_WITH_COVERAGE = 1
+test-serial+coverage: test-serial
 
 coverage-report: coverage/index.html
 	sensible-browser $< > /dev/null 2>&1 &
 
-coverage.xml: bin/coverage coverage.data
-	bin/coverage xml --include 'src/*' -o $@
+coverage.xml: bin/coverage .coverage
+	bin/coverage xml -o $@
 
 coverage/index.html: revno = $(or $(shell bzr revno 2>/dev/null),???)
-coverage/index.html: bin/coverage coverage.data
+coverage/index.html: bin/coverage .coverage
 	@$(RM) -r $(@D)
-	bin/coverage html --include 'src/*' \
-	    --omit 'src/*/tests/*,src/*/testing/*' \
-	    --title "MAAS r$(revno)" --directory $(@D)
-
-coverage.data:
-	@$(error Use `$(MAKE) test+coverage` to generate coverage data, \
-	    or invoke a test script using the `--with-coverage` flag)
-
-lint: lint-py lint-py-complexity lint-py-imports lint-js lint-doc lint-rst
+	bin/coverage html \
+	    --title "Coverage for MAAS r$(revno)" \
+	    --directory $(@D)
+
+.coverage:
+	@$(error Use `$(MAKE) test` to generate coverage)
+
+lint: \
+    lint-py lint-py-complexity lint-py-imports \
+    lint-js lint-junk lint-doc lint-rst
 
 pocketlint = $(call available,pocketlint,python-pocket-lint)
 
@@ -289,7 +304,7 @@
 lint-py: bin/flake8
 	@find $(sources) -name '*.py' \
 	  ! -path '*/migrations/*' ! -path '*/south_migrations/*' -print0 \
-	    | xargs -r0 bin/flake8 --ignore=E123,E402,E731 --isolated
+	    | xargs -r0 bin/flake8 --ignore=E123,E305,E402,E731 --isolated
 
 # Ignore tests when checking complexity. The maximum complexity ought to
 # be close to 10 but MAAS has many functions that are over that so we
@@ -300,7 +315,7 @@
 	@find $(sources) -name '*.py' \
 	  ! -path '*/migrations/*' ! -path '*/south_migrations/*' \
 	  ! -path '*/tests/*' ! -path '*/testing/*' ! -name 'testing.py' \
-	  -print0 | xargs -r0 bin/flake8 --ignore=E123,E402,E731 \
+	  -print0 | xargs -r0 bin/flake8 --ignore=E123,E305,E402,E731 \
 	              --isolated --max-complexity=$(maximum)
 
 # Statically check imports against policy.
@@ -323,6 +338,11 @@
 	    '(' -name '*.html' -o -name '*.js' ')' -print0 \
 		| xargs -r0 -n20 -P4 $(pocketlint)
 
+# Sometimes junk gets added to MAAS, like .moved files.
+lint-junk:
+	@if bzr ls --recursive --versioned | egrep '[.]moved$$'; then \
+	    echo "^ Junk found. Please remove it from the tree." >&2 ; fi
+
 # Apply automated formatting to all Python files.
 format: sources = $(wildcard *.py contrib/*.py) src templates twisted utilities etc
 format:
@@ -360,23 +380,3 @@
 man/%: docs/man/%.rst | bin/sphinx-build
 	bin/sphinx-build -b man docs man $^
 
-enums: $(js_enums)
-
-$(js_enums): bin/py src/maasserver/utils/jsenums.py $(py_enums)
-	bin/py -m maasserver.utils.jsenums $(py_enums) > $@
-
-styles: clean-styles $(scss_output)
-
-$(scss_output): bin/sass $(scss_theme) $(scss_inputs)
-	bin/sass --include-path=src/maasserver/static/scss \
-	    --output-style compressed $(scss_inputs) -o $(dir $@)
-
-$(scss_theme): prefix = include/nodejs
-$(scss_theme):
-	$(npm_install) --prefix $(prefix) cloud-vanilla-theme@0.0.22
-
-clean-styles:
-	$(RM) $(scss_output)
-
-clean: stop clean-run clean-failed
-	find . -type f -name '*.py[co]' -print0 | xargs -r0 $(RM)

=== debian/changelog ===
maas (2.2.0~rc1+bzr5922-0ubuntu2) zesty; urgency=medium

  * Bump depends version on python3-curtin. (LP: #1680175)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 05 Apr 2017 13:51:58 -0400

maas (2.2.0~rc1+bzr5922-0ubuntu1) zesty; urgency=medium

  * New upstream release, MAAS 2.2.0 RC 1. (FFe LP: #1667141)
  * debian/maas-common.logrotate: Rotate maas.log weekly, instead of daily.
    Store logs for 8 weeks. (LP: #1677005)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Tue, 28 Mar 2017 11:08:38 -0400

maas (2.2.0~beta4+bzr5856-0ubuntu1) zesty; urgency=medium

  * New upstream release, MAAS 2.2.0 Beta 4. (FFe LP: #1667141)
    - Add support to disable components.
    - Improve RSD details page. Show composed machines and power tab.
    - Add NTP & Internet connectivity tests.
    - UX improvements - Change to new tab system to improve navigation.
    - Error surfacing - For interfaces of Machines & Devices.
    - Windows deployments - support to select the root/boot disk.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 16 Mar 2017 16:10:26 +0000

maas (2.2.0~beta3+bzr5815-0ubuntu1) zesty; urgency=medium

  * New upstream release. MAAS 2.2.0 Beta 3 (FFe LP: #1667141):
    - Introduce storage verification smoke tests.
    - Introduce notifications API.
    - Add device details page.
    - Introduce Wedge BMC discovery during commissioning.
    - Add pod listing & details page.
    - Add dynamic composition for virsh devices.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 15 Feb 2017 08:37:25 -0500

maas (2.2.0~beta2+bzr5717-0ubuntu1) zesty; urgency=medium

  * New upstream release. MAAS 2.2.0 Beta 2 (bzr5717):
    - Introduce initial support for Intel RSD.
    - Introduce IPv6 IPMI auto-discovery.
    - Introduce notifications.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 30 Jan 2017 15:55:02 -0500

maas (2.2.0~beta1+bzr5675-0ubuntu1) zesty; urgency=medium

  * New upstream release. MAAS 2.2.0 Beta 1 (bzr5675):
    - Changing the concept of Spaces to a L2 layer.
    - Support for DHCP relays.
    - Introduce the concept of UNMANAGED subnets.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 11 Jan 2017 13:34:46 +0200

maas (2.2.0~alpha1+bzr5614-0ubuntu1) zesty; urgency=medium

  * New upstream release. MAAS 2.2.0 Alpha 1 (bzr5614):
    - Don't install Django settings into /usr/share/maas/maas. For
      regiond these were squatting the `maas` namespace, preventing its
      use elsewhere (LP: #1646748)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 21 Nov 2016 20:01:31 -0500

maas (2.1.1+bzr5501-0ubuntu1) zesty; urgency=medium

  * MAAS new upstream bugfix release. MAAS 2.1.1 bzr 5544.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 24 Oct 2016 11:28:59 -0400

maas (2.1.0+bzr5480-0ubuntu1) yakkety; urgency=medium

  * MAAS new upstream bugfix release. MAAS 2.1.0 (0-day SRU LP: #1633064):
    - TestPartition.test_get_partition_number_returns_starting_at_2_for_ppc64el
      fails spuriously (LP: #1569365)
    - "Deployed" and "Deploying" are too similar (LP: #1598470)
    - Users' maas api keys do not have a name (LP: #1536354)
    - [2.1] Incorrect logging message - showing SERVICE_STATE.ON (LP: #1631358)
    - [2.1 UI] Images page "Queued for download" is confusing when selections
      are not saved (LP: #1631420)
    - [2.1b1] Dashboard column widths for discovered items are
      wonky (LP: #1631024)
    - [2.1b1] 'Registering existing rack controller' (LP: #1631022)
    - [2.1] Command 'interface link-subnet' does not work (LP: #1629604)
    - [FUJ] SSH input field not indicated for invalid username & the error
      is incomprehensible (LP: #1628114)
    - [2.1 ipv6] DHCP generation should not fail when address-family
      conflicts are present (LP: #1629475)
    - [2.0rc2] Commissioning node with gateway_link_v4 set fails. (LP: #1603466)
    - [2.1, 2.0 UI] Error when using dhcp range with pre-existing dynamic
      reservation (LP: #1608555)
    - [2.1b2] Node failed to be released, because of the following error:
      'NoneType' object has no attribute 'addErrback' (LP: #1632815)
    - [2.1, Yakkety, UI] UI error when adding a chassis (LP: #1632395)
    - [2.0, 2.1 UI] Other reserved IP ranges disappear when one of them is
      deleted on Subnet details page. (LP: #1631079)
    - [2.1b1] MAAS fails to deploy systems with 3+ TB disks (LP: #1630667)
    - [2.1 Yakkety UI] Unable to select nodes (LP: #1630633)
    - [2.0, 2.1] Release and list IPs reserved by another user (LP: #1629061)
    - [2.0rc2] Changing DNSSEC validation does not trigger configuration
      file update (LP: #1605476)
    - [2.1] Failed to mount a partition and it doesn't surface error. (LP: #1631152)
    - [2.1. Yakkety] "Map subnet" action doesn't work. (LP: #1632862)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 05 Oct 2016 21:47:25 -0400

maas (2.1.0~alpha4+bzr5397-0ubuntu1) yakkety; urgency=medium

  * MAAS new upstream release, MAAS 2.1.0 alpha 4 (bzr5397):
    - Complete First User Journey (Ability to import keys from GH/LP).
    - User profile has ability to import keys from GH/LP as well.
    - Device discovery:
      - Ability to clear records that may be incorrect.
      - Ability to 'Map networks' via the API.
    - Import NTP configuration via vendor-data and DHCP.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 19 Sep 2016 17:21:47 -0400

maas (2.1.0~alpha3+bzr5368-0ubuntu1) yakkety; urgency=medium

  * New upstream release, MAAS 2.1.0 Alpha 3 (bzr5363):
    - First user journey (SSH key import not yet available).
    - Allow the user to import SSH keys from LP or GH (only API/CLI).
    - Provide NTP services. Region and Rack Controllers now provide NTP
      services. Machines are also deployed with NTP configuration via.
      + Add cloud-init vendor data to support configuring the machine with
        NTP settings.
    - Images page complete redesign and transition to AngularJS.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 19 Sep 2016 17:21:20 -0400



=== debian/control ===
--- 
+++ 
@@ -128,7 +128,7 @@
          python3-attr,
          python3-bson,
          python3-crochet,
-         python3-curtin (>> 0.1.0~bzr351),
+         python3-curtin (>> 0.1.0~bzr478),
          python3-distro-info,
          python3-formencode,
          python3-jsonschema,
@@ -242,9 +242,10 @@
          python3-attr,
          python3-convoy,
          python3-crochet,
-         python3-curtin (>> 0.1.0~bzr275),
+         python3-curtin (>> 0.1.0~bzr478),
          python3-lxml,
          python3-maas-client (= ${binary:Version}),
+         python3-markupsafe,
          python3-netaddr,
          python3-psycopg2,
          python3-sphinx,
